summary | shortlog | log | commit | commitdiff | tree
raw | patch | inline | side by side (parent: 70af4e9)
raw | patch | inline | side by side (parent: 70af4e9)
author | David Aguilar <davvid@gmail.com> | |
Sun, 12 Apr 2009 03:41:56 +0000 (20:41 -0700) | ||
committer | Junio C Hamano <gitster@pobox.com> | |
Sun, 12 Apr 2009 22:19:12 +0000 (15:19 -0700) |
The mergetool--lib scriplet was tricky to use because it relied upon
the existance of several global shell variables. This removes more
global variables so that things are simpler for callers.
A side effect is that some variables are recomputed each time
run_merge_tool() is called, but the overhead for recomputing
them is justified by the simpler implementation.
Signed-off-by: David Aguilar <davvid@gmail.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
the existance of several global shell variables. This removes more
global variables so that things are simpler for callers.
A side effect is that some variables are recomputed each time
run_merge_tool() is called, but the overhead for recomputing
them is justified by the simpler implementation.
Signed-off-by: David Aguilar <davvid@gmail.com>
Signed-off-by: Junio C Hamano <gitster@pobox.com>
Documentation/git-mergetool--lib.txt | patch | blob | history | |
git-difftool--helper.sh | patch | blob | history | |
git-mergetool--lib.sh | patch | blob | history | |
git-mergetool.sh | patch | blob | history |
index 3d57031d78d9e274890ab2264adcbc95980646d0..78eb03f0ae864f67faac55f450bf0fd2be3416b3 100644 (file)
SYNOPSIS
--------
-'. "$(git --exec-path)/git-mergetool--lib"'
+'TOOL_MODE=(diff|merge) . "$(git --exec-path)/git-mergetool--lib"'
DESCRIPTION
-----------
`.`) by other shell scripts to set up functions for working
with git merge tools.
-Before sourcing it, your script should set up a few variables;
-`TOOL_MODE` is used to define the operation mode for various
-functions. 'diff' and 'merge' are valid values.
+Before sourcing 'git-mergetool--lib', your script must set `TOOL_MODE`
+to define the operation mode for the functions listed below.
+'diff' and 'merge' are valid values.
FUNCTIONS
---------
get_merge_tool::
- returns a merge tool
+ returns a merge tool.
get_merge_tool_cmd::
returns the custom command for a merge tool.
run_merge_tool::
launches a merge tool given the tool name and a true/false
flag to indicate whether a merge base is present.
- '$merge_tool', '$merge_tool_path', and for custom commands,
- '$merge_tool_cmd', must be defined prior to calling
- run_merge_tool. Additionally, '$MERGED', '$LOCAL', '$REMOTE',
- and '$BASE' must be defined for use by the merge tool.
+ '$MERGED', '$LOCAL', '$REMOTE', and '$BASE' must be defined
+ for use by the merge tool.
Author
------
index b4500368c3268bb26aa22ccf75b9b2fd4bc94df1..57e8e3256d7b6578cda37815163d8945431aa6db 100755 (executable)
--- a/git-difftool--helper.sh
+++ b/git-difftool--helper.sh
test -n "$GIT_MERGE_TOOL" && merge_tool="$GIT_MERGE_TOOL"
test -n "$GIT_DIFF_TOOL" && merge_tool="$GIT_DIFF_TOOL"
-merge_tool=$(get_merge_tool "$merge_tool") || exit
-merge_tool_cmd="$(get_merge_tool_cmd "$merge_tool")"
-merge_tool_path="$(get_merge_tool_path "$merge_tool")" || exit
+if test -z "$merge_tool"; then
+ merge_tool="$(get_merge_tool)" || exit
+fi
# Launch the merge tool on each path provided by 'git diff'
while test $# -gt 6
diff --git a/git-mergetool--lib.sh b/git-mergetool--lib.sh
index c5db24e45dd9538528c64bcb3b0bd8ebf71a6771..a16a2795d70779365212c09b6d0dd42d1746842b 100644 (file)
--- a/git-mergetool--lib.sh
+++ b/git-mergetool--lib.sh
}
translate_merge_tool_path () {
- if test -n "$2"; then
- echo "$2"
- else
- case "$1" in
- vimdiff)
- path=vim
- ;;
- gvimdiff)
- path=gvim
- ;;
- emerge)
- path=emacs
- ;;
- *)
- path="$1"
- ;;
- esac
- echo "$path"
- fi
+ case "$1" in
+ vimdiff)
+ echo vim
+ ;;
+ gvimdiff)
+ echo gvim
+ ;;
+ emerge)
+ echo emacs
+ ;;
+ *)
+ echo "$1"
+ ;;
+ esac
}
check_unchanged () {
}
get_merge_tool_cmd () {
- diff_mode &&
- custom_cmd="$(git config difftool.$1.cmd)"
- test -z "$custom_cmd" &&
- custom_cmd="$(git config mergetool.$1.cmd)"
- test -n "$custom_cmd" &&
- echo "$custom_cmd"
+ # Prints the custom command for a merge tool
+ if test -n "$1"; then
+ merge_tool="$1"
+ else
+ merge_tool="$(get_merge_tool)"
+ fi
+ if diff_mode; then
+ echo "$(git config difftool.$merge_tool.cmd ||
+ git config mergetool.$merge_tool.cmd)"
+ else
+ echo "$(git config mergetool.$merge_tool.cmd)"
+ fi
}
run_merge_tool () {
+ merge_tool_path="$(get_merge_tool_path "$1")" || exit
base_present="$2"
status=0
status=$?
else
("$merge_tool_path" --auto \
- --L1 "$MERGED (A)" \
- --L2 "$MERGED (B)" "$LOCAL" "$REMOTE" \
- > /dev/null 2>&1)
+ --L1 "$MERGED (A)" \
+ --L2 "$MERGED (B)" "$LOCAL" "$REMOTE" \
+ > /dev/null 2>&1)
fi
;;
kompare)
fi
;;
*)
+ merge_tool_cmd="$(get_merge_tool_cmd "$1")"
if test -z "$merge_tool_cmd"; then
if merge_mode; then
status=1
break
fi
if merge_mode; then
- if test "$merge_tool_trust_exit_code" = "false"; then
+ trust_exit_code="$(git config --bool \
+ mergetool."$1".trustExitCode || echo false)"
+ if test "$trust_exit_code" = "false"; then
touch "$BACKUP"
( eval $merge_tool_cmd )
check_unchanged
do
merge_tool_path="$(translate_merge_tool_path "$i")"
if type "$merge_tool_path" > /dev/null 2>&1; then
- merge_tool="$i"
- break
+ echo "$i"
+ return 0
fi
done
- if test -z "$merge_tool" ; then
- echo >&2 "No known merge resolution program available."
- return 1
- fi
- echo "$merge_tool"
+ echo >&2 "No known merge resolution program available."
+ return 1
}
get_configured_merge_tool () {
# Diff mode first tries diff.tool and falls back to merge.tool.
# Merge mode only checks merge.tool
if diff_mode; then
- tool=$(git config diff.tool)
- fi
- if test -z "$tool"; then
- tool=$(git config merge.tool)
+ merge_tool=$(git config diff.tool || git config merge.tool)
+ else
+ merge_tool=$(git config merge.tool)
fi
if test -n "$merge_tool" && ! valid_tool "$merge_tool"; then
echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
echo >&2 "Resetting to default..."
return 1
fi
- echo "$tool"
+ echo "$merge_tool"
}
get_merge_tool_path () {
# A merge tool has been set, so verify that it's valid.
+ if test -n "$1"; then
+ merge_tool="$1"
+ else
+ merge_tool="$(get_merge_tool)"
+ fi
if ! valid_tool "$merge_tool"; then
echo >&2 "Unknown merge tool $merge_tool"
exit 1
fi
if diff_mode; then
- merge_tool_path=$(git config difftool."$merge_tool".path)
+ merge_tool_path=$(git config difftool."$merge_tool".path ||
+ git config mergetool."$merge_tool".path)
+ else
+ merge_tool_path=$(git config mergetool."$merge_tool".path)
fi
if test -z "$merge_tool_path"; then
- merge_tool_path=$(git config mergetool."$merge_tool".path)
+ merge_tool_path="$(translate_merge_tool_path "$merge_tool")"
fi
- merge_tool_path="$(translate_merge_tool_path "$merge_tool" "$merge_tool_path")"
- if test -z "$merge_tool_cmd" && ! type "$merge_tool_path" > /dev/null 2>&1; then
- echo >&2 "The $TOOL_MODE tool $merge_tool is not available as '$merge_tool_path'"
+ if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
+ ! type "$merge_tool_path" > /dev/null 2>&1; then
+ echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
+ "'$merge_tool_path'"
exit 1
fi
echo "$merge_tool_path"
}
get_merge_tool () {
- merge_tool="$1"
# Check if a merge tool has been configured
- if test -z "$merge_tool"; then
- merge_tool=$(get_configured_merge_tool)
- fi
+ merge_tool=$(get_configured_merge_tool)
# Try to guess an appropriate merge tool if no tool has been set.
if test -z "$merge_tool"; then
- merge_tool=$(guess_merge_tool) || exit
+ merge_tool="$(guess_merge_tool)" || exit
fi
echo "$merge_tool"
}
diff --git a/git-mergetool.sh b/git-mergetool.sh
index 2e3e02b3b5b45af781fea529e9f3f68fce4a9bd0..b52a7410bcb7b37dce0f4d6213dddedd2c1e42e7 100755 (executable)
--- a/git-mergetool.sh
+++ b/git-mergetool.sh
read ans
fi
- present=false
- base_present &&
- present=true
+ if base_present; then
+ present=true
+ else
+ present=false
+ fi
if ! run_merge_tool "$merge_tool" "$present"; then
echo "merge of $MERGED failed" 1>&2
done
}
-merge_tool=$(get_merge_tool "$merge_tool") || exit
-merge_tool_cmd="$(get_merge_tool_cmd "$merge_tool")"
-merge_tool_path="$(get_merge_tool_path "$merge_tool")" || exit
+if test -z "$merge_tool"; then
+ merge_tool=$(get_merge_tool "$merge_tool") || exit
+fi
merge_keep_backup="$(git config --bool mergetool.keepBackup || echo true)"
merge_keep_temporaries="$(git config --bool mergetool.keepTemporaries || echo false)"
-merge_tool_trust_exit_code="$(git config --bool mergetool."$merge_tool".trustExitCode || echo false)"
last_status=0
rollup_status=0